{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$Q-}
{$R-}
{$S-}
{$D-}

//////////////////////////////////////////////////////////////////////////
// Copyright (c) 2002 by Christian T. Magnus aka VENOM, Venom Software. //
// All rights reserved.                                                 //
//////////////////////////////////////////////////////////////////////////




// Visit http://www.venomsoftware.de

// CONTACT :  webmaster@venomsoftware.de      // website eMail
//            chtm@gmx.de                     // private eMail





{
  $Id: VGFX_Files.pp, 2002/08/01 Christian Tobias Magnus

  Fast graphic unit for Free Pascal 32 Bit.
  Full compatible and tested on Win95/98/98SE/NT/ME/2000/XP

  This unit is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation;

  You are not allowed to use this unit for commercial purposes
  without the authors permission. Also you are not allowed to
  make modified version public without the authors permission.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  This unit is part of VGFX !

  Would be nice if you mention the author of this unit in your
  own releases to give him a little tribute... thanx !
}






UNIT VGFX_Files;


INTERFACE




USES     Windows,Sysutils,
         Bigfile2,
         VGFX_Errors,
         VGFX;






FUNCTION    File2Mem     (Datei         :String; var Target:Pointer):Longint;
FUNCTION BigFile2Mem     (Datei,BigDatei:String; var Target:Pointer):Longint;

FUNCTION FileSpr2Mem     (Datei         :String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
FUNCTION BigFileSpr2Mem  (Datei,BigDatei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;





{---------------------------------------------------------------------------}




IMPLEMENTATION



CONST  Copyright = 'Copyright (c) 2002 by Christian T. Magnus aka Venom, Venom Software. All rights reserved.';









FUNCTION File2Mem(Datei:String; var Target:Pointer):Longint;
VAR      Dat     : File;
Begin
 Assign(Dat,Datei);
 {$I-}
 Reset(Dat,1);
 {$I+}
 If IOResult<>0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'File : '+Datei);

 File2Mem:= FileSize(Dat);

 Target:= Nil;
 AllokPtrSpeicher(Target,FileSize(Dat));

 BlockRead(Dat,Target^,FileSize(Dat));
 Close(Dat);
End;



FUNCTION BigFile2Mem(Datei,BigDatei:String; var Target:Pointer):Longint;
VAR      BigDat,Error : Byte;
         Dat          : Word;
Begin
 BigDat:= BIGOPEN(BigDatei);
 If BigDat>244 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Internal error message : '+#13+ErrorString(BigDat)+#13+#13+'File : '+BigDatei);
  Dat:= OpenFile(BigDat,Datei);

   If Dat=0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Error occured while open sub file "'+Datei+'" of main file "'+BigDatei+'" ! ');

   BigFile2Mem:= SizeFile(BigDat,Dat);

   Target:= Nil;
   AllokPtrSpeicher(Target,Sizefile(BigDat,Dat));

   Error:= ReadBig(BigDat,Dat,Target,Sizefile(BigDat,Dat));

   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

  CloseFile(BigDat,Dat);
 BigClose(BigDat);
End;



{---------------------------------------------------------------------------}



FUNCTION FileSpr2Mem(Datei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
VAR      Dat : File;
Begin
 Assign(Dat,Datei);
 {$I-}
 Reset(Dat,1);
 {$I+}
 If IOResult<>0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'File : '+Datei);

 FileSpr2Mem:= FileSize(Dat);

 Target:= Nil;
 AllokPtrSpeicher(Target,FileSize(Dat)-4);

 BlockRead(Dat,           Target^,FileSize(Dat)-4);
 BlockRead(Dat,Addr(BreiteHoehe)^,              4);
 Close(Dat);
End;



FUNCTION BigFileSpr2Mem(Datei,BigDatei:String; var Target:Pointer;var BreiteHoehe:Longint):Longint;
VAR      BigDat,Error : Byte;
         Dat          : Word;
Begin
 BigDat:= BIGOPEN(BigDatei);
 If BigDat>244 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Internal error message : '+#13+ErrorString(BigDat)+#13+#13+'File : '+BigDatei);
  Dat:= OpenFile(BigDat,Datei);

   If Dat=0 then ERRORM(IO_ErrorHeadline,IO_ErrorReadAccess+#13+#13+'Error occured while open sub file "'+Datei+'" of main file "'+BigDatei+'" ! ');

   BigFileSpr2Mem:= SizeFile(BigDat,Dat);

   Target:= Nil;
   AllokPtrSpeicher(Target,Sizefile(BigDat,Dat));

   Error:= ReadBig(BigDat,Dat,Target,Sizefile(BigDat,Dat)-4);
   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

   Error:= ReadBig(BigDat,Dat,Addr(BreiteHoehe),          4);
   If Error<>0 then ERRORM('I/O Error !','An error occured when trying to load sub file "'+Datei+'" from main file "'+BigDatei+'" ! ');

  CloseFile(BigDat,Dat);
 BigClose(BigDat);
End;


(******************************** INIT UNIT *********************************)


BEGIN

END.

