{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$Q-}
{$R-}
{$S-}
{$D-}


//////////////////////////////////////////////////////////////////////////
// Copyright (c) 2002 by Christian T. Magnus aka VENOM, Venom Software. //
// All rights reserved.                                                 //
//////////////////////////////////////////////////////////////////////////





// Visit http://www.venomsoftware.de

// CONTACT :  webmaster@venomsoftware.de      // website eMail
//            chtm@gmx.de                     // private eMail





{
  $Id: VGFX_Text.pp, 2002/08/01 Christian Tobias Magnus

  Fast graphic unit for Free Pascal 32 Bit.
  Full compatible and tested on Win95/98/98SE/NT/ME/2000/XP

  This unit is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation;

  You are not allowed to use this unit for commercial purposes
  without the authors permission. Also you are not allowed to
  make modified version public without the authors permission.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  This unit is part of VGFX !

  Would be nice if you mention the author of this unit in your
  own releases to give him a little tribute... thanx !
}







UNIT VGFX_Text;


INTERFACE



USES      VGFX,
          VGFX_2D,
          VGFX_Files,
          VGFX_Errors,
          Bigfile2;




{---------------------------------------------------------------------------}

 PROCEDURE Load_Fonts   (   Datei:String);
 PROCEDURE BigLoad_Fonts(BigDatei:String);

 PROCEDURE SetTextSize(Size:Word);
 FUNCTION  GetTextSize : Word;

 PROCEDURE Moveto1(x,y:Word);
 FUNCTION  Getx1 : Word;
 FUNCTION  Gety1 : Word;

 PROCEDURE Outtextxy(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
 PROCEDURE Outtext  (Dest:VirtualWindow;            r,g,b:Word;Ketten:String);

 PROCEDURE Moveto2(x,y:Word);
 FUNCTION  Getx2 : Word;
 FUNCTION  Gety2 : Word;

 PROCEDURE Outtextxy2(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
 PROCEDURE Outtext2  (Dest:VirtualWindow;            r,g,b:Word;Ketten:String);

 { Slow but smoother }

 PROCEDURE Textatxy(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
 PROCEDURE Textat  (Dest:VirtualWindow;            r,g,b:Word;Ketten:String);

 PROCEDURE Textatxy2(Dest:VirtualWindow;x,y:Longint;r,g,b:Word;Ketten:String);
 PROCEDURE Textat2  (Dest:VirtualWindow;            r,g,b:Word;Ketten:String);

{---------------------------------------------------------------------------}




IMPLEMENTATION


CONST   Copyright = 'Copyright (c) 2002 by Christian T. Magnus, Venom Software. All rights reserved.';

VAR     TextSize 	        : Word;
        xpos1,ypos1         : Word;
        xpos2,ypos2         : Word;
        Kette               : String;
        FontVariable        : Array[0..3503] of Byte;




{---------------------------------------------------------------------------}

PROCEDURE SetTextSize(Size:Word);
Begin
 TextSize:= Size;
End;


FUNCTION Gettextsize:Word;
Begin
 Gettextsize:= textsize;
End;


PROCEDURE Moveto1(x,y:Word); Assembler;
Asm
 Mov ax,x
 Mov xpos1,ax
 Mov ax,y
 Mov ypos1,ax
End;


PROCEDURE Moveto2(x,y:Word); Assembler;
Asm
 Mov ax,x
 Mov xpos2,ax
 Mov ax,y
 Mov ypos2,ax
End;


FUNCTION Getx1:Word; Begin Getx1:=xpos1; End;
FUNCTION Gety1:Word; Begin Gety1:=ypos1; End;

FUNCTION Getx2:Word; Begin Getx2:=xpos2; End;
FUNCTION Gety2:Word; Begin Gety2:=ypos2; End;


PROCEDURE Load_Fonts(Datei:String);
VAR       FontPointer  : Pointer;
          FontByteSize : LongInt;
Begin
 FontByteSize:= File2Mem(Datei,FontPointer);
 Move(FontPointer^,FontVariable,FontByteSize);
 FreePtrSpeicher(FontPointer);
End;


PROCEDURE BigLoad_Fonts(BigDatei:String);
VAR       FontPointer  : Pointer;
          FontByteSize : LongInt;
Begin
 FontByteSize:= BigFile2Mem('Fonts.fnt',BigDatei,FontPointer);
 Move(FontPointer^,FontVariable,FontByteSize);
 FreePtrSpeicher(FontPointer);
End;


PROCEDURE Outtextxy(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
VAR       q,q2,q3,q4,q5,q6,q7 : Byte;
Begin
 ypos1:=y;
 q6   :=length(ketten);
 xpos1:=x+q6*(textsize shl 3);
 q7   :=textsize-1;
 For q:= 1 to q6 do
 begin
  For q2:= 0 to 7 do
  begin
   Kette:=DezToBin(FontVariable[(ord(Ketten[q]) shl 3)+q2]);
   For q3:=0 to 7 do If Kette[q3+1]='1' then
   for q4:=0 to q7 do
   for q5:=0 to q7 do
   PutClippedPixel(Dest,x+q5+q3*textsize+(q-1)*(textsize shl 3),y+q4+(q2*textsize),r,g,b);
  end;
 end;
End;


PROCEDURE Outtext(Dest:VirtualWindow;r,g,b:Word;Ketten:String);
Begin
 Outtextxy(Dest,xpos1,ypos1,r,g,b,Ketten);
End;


PROCEDURE Outtextxy2(Dest:VirtualWindow;x,y:Longint;r,g,b:Word;Ketten:String);
VAR       q,q2,q3,q4,q5,q6,q7 : Byte;
Begin
 ypos2:=y;
 q6   :=length(Ketten);
 xpos2:=x+q6*(textsize shl 3);
 q7   :=textsize-1;
 For q:= 1 to q6 do
 begin
  For q2:= 0 to 15 do
  begin
   Kette:=DezToBin(FontVariable[2048+((ord(Ketten[q])-32) shl 4)+q2]);
   For q3:=0 to 7 do If Kette[q3+1]='1' then
   for q4:=0 to q7 do
   for q5:=0 to q7 do
   PutClippedPixel(Dest,x+q5+(q3*textsize)+(q-1)*(textsize shl 3),y+q4+(q2*textsize),r,g,b);
  end;
 end;
End;


PROCEDURE Outtext2(Dest:VirtualWindow;r,g,b:Word;Ketten:String);
Begin
 Outtextxy2(Dest,xpos2,ypos2,r,g,b,Ketten);
End;


PROCEDURE Textatxy(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
VAR       r2,g2,b2 : Word;
Begin
 If r<10 then r2:=0 else r2:=r-10;
 If g<20 then g2:=0 else g2:=g-20;
 If b<10 then b2:=0 else b2:=b-10;
 Outtextxy(Dest,x-1,y  ,r2,g2,b2,Ketten);
 Outtextxy(Dest,x  ,y-1,r2,g2,b2,Ketten);
 Outtextxy(Dest,x+1,y  ,r2,g2,b2,Ketten);
 Outtextxy(Dest,x  ,y+1,r2,g2,b2,Ketten);
 Outtextxy(Dest,x  ,y  , r, g, b,Ketten);
End;


PROCEDURE TextAt(Dest:VirtualWindow;r,g,b:Word;Ketten:String);
VAR       r2,g2,b2  : Word;
          Oldx,Oldy : LongInt;
Begin
 If r<10 then r2:=0 else r2:=r-10;
 If g<20 then g2:=0 else g2:=g-20;
 If b<10 then b2:=0 else b2:=b-10;
 Oldx:=xpos1;
 Oldy:=ypos1;
 MoveTo1(oldx-1,oldy  ); Outtext(Dest,r2,g2,b2,Ketten);
 MoveTo1(oldx  ,oldy-1); Outtext(Dest,r2,g2,b2,Ketten);
 MoveTo1(oldx+1,oldy  ); Outtext(Dest,r2,g2,b2,Ketten);
 MoveTo1(oldx  ,oldy+1); Outtext(Dest,r2,g2,b2,Ketten);
 MoveTo1(oldx  ,oldy  ); Outtext(Dest, r, g, b,Ketten);
End;


PROCEDURE TextAtxy2(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word;Ketten:String);
VAR       r2,g2,b2 : Word;
Begin
 If r<10 then r2:=0 else r2:=r-10;
 If g<20 then g2:=0 else g2:=g-20;
 If b<10 then b2:=0 else b2:=b-10;
 Outtextxy2(Dest,x-1,y  ,r2,g2,b2,Ketten);
 Outtextxy2(Dest,x  ,y-1,r2,g2,b2,Ketten);
 Outtextxy2(Dest,x+1,y  ,r2,g2,b2,Ketten);
 Outtextxy2(Dest,x  ,y+1,r2,g2,b2,Ketten);
 Outtextxy2(Dest,x  ,y  , r, g, b,Ketten);
End;


PROCEDURE Textat2(Dest:VirtualWindow;r,g,b:Word;Ketten:String);
VAR       r2,g2,b2  : Word;
          Oldx,Oldy : LongInt;
Begin
 If r<10 then r2:=0 else r2:=r-10;
 If g<20 then g2:=0 else g2:=g-20;
 If b<10 then b2:=0 else b2:=b-10;
 Oldx:=xpos2;
 Oldy:=ypos2;
 MoveTo2(oldx-1,oldy  ); Outtext2(Dest,r2,g2,b2,Ketten);
 MoveTo2(oldx  ,oldy-1); Outtext2(Dest,r2,g2,b2,Ketten);
 MoveTo2(oldx+1,oldy  ); Outtext2(Dest,r2,g2,b2,Ketten);
 MoveTo2(oldx  ,oldy+1); Outtext2(Dest,r2,g2,b2,Ketten);
 MoveTo2(oldx  ,oldy  ); Outtext2(Dest, r, g, b,Ketten);
End;



(******************************** INIT UNIT *********************************)


BEGIN
 Settextsize(1);
 MoveTo1(0,0);
 MoveTo2(0,0);
END.

